/*	Main Forms Table	*/
drop table creator_table;
drop table all_students_table;
drop table answer_table;
drop table student_table;
drop table question_table;
drop  table forms;
create table forms(
	form_number	varchar(10) not null,
	/* --- course_number	varchar(5) not null, --- */
	description	varchar(50),
	release_date	date,
	fill_date	date,
	anonymous 	varchar(1),
	state		varchar(1),
	constraint pk_forms primary key (form_number));

/*	Question Table	*/
create table question_table(
	form_number		varchar(10) not null,
	constraint fk_question foreign key (form_number) references forms 
	on delete cascade,
	question_number 	integer not null,
	question_type 		integer not null,
	question_text 		varchar(500) not null,
	/* Multiple Choice Question */
	total_options		number(1),
	constraint option_limit check(total_options <= 5),
	option_1		varchar(10),
	option_2		varchar(10),
	option_3		varchar(10),
	option_4		varchar(10),
	option_5		varchar(10),
	/* Range Type Questions		*/
	ulimit			number(10,2) null,
	llimit			number(10,2) null,
	constraint range_constraint check(ulimit >= llimit),
	constraint pk_qtable primary key (question_number,form_number));

/* Student Table	*/
create table student_table(
	form_number	varchar(10) not null,
	constraint fk_student foreign key (form_number) references forms 
	on delete cascade,
        login_id        varchar(10) not null,
        passwd          varchar(10) not null,
	valid		varchar(1),
        primary key (login_id,form_number));

/* Defined user List	*/
create table all_students_table(
        login_id        varchar(10) not null,
        passwd          varchar(10) not null,
	user_type	varchar(10),
        primary key (login_id));

/* Answer 	Table	*/
create  table answer_table(
	form_number 	varchar(10) not null,
	question_number integer not null,
	answer_number	integer not null,
	constraint fk_answer foreign key (question_number,form_number) 
	references question_table,
	constraint pk_answer primary key (form_number,question_number,answer_number),
	answer_option	number(2),
	mult_1		char(1),
	mult_2		char(1),
	mult_3		char(1),
	mult_4		char(1),
	mult_5		char(1),
	answer_value	number(10,2),
	answer_text	varchar(100),
	login_id	varchar(10));

 /*  List of authorized form creators  */
create table creator_table(
	login_id varchar(10),
	passwd varchar(10));
	
