/*	Main Forms Table	*/
drop  table forms;
create table forms(
	form_number	varchar(10) not null,
	course_number	varchar(5) not null,
	description	varchar(50),
//	student_table	varchar(20),
//	question_table	varchar(20) not null,
	release_date	date,
	fill_date	date,
	constraint pk_forms primary key (form_number));

/*	Question Table	*/
/* The name of question table is qtable followed by the form_number	*/
/* In this case for form number 1					*/
drop table qtable;
create table qtable(
	form_number		varchar(10) not null,
	constraint fk_qtable foreign key (form_number),
	question_number 	varchar(10) not null,
	question_type 		integer not null,
	question_text 		varchar(100) not null,
	/* Multiple Choice Question */
	total_options		number(1) null,
	constraint option_limit check(total_options <= 5),
	option_1		varchar(10),
	option_2		varchar(10),
	option_3		varchar(10),
	option_4		varchar(10),
	option_5		varchar(10),
	/* Range Type Questions		*/
	ulimit			number(10,2) null,
	llimit			number(10,2) null,
	constraint range_constraint check(ulimit >= llimit),
	answer_table		varchar(20) not null,
	constraint pk_qtable primary key (question_number,form_number));


/* Student Table	*/
drop table studenttable_1;
create table studenttable_1(
	login_id	varchar(10) not null,
	passwd		varchar(10) not null,
	cookie		varchar(100),
	primary key (login_id));
/* Answer 	Table	*/
/* Format : answertable_[form_no]_[question_type]	*/
/* Multiple Choice Single Answer */
drop table answertable_1_1;
create table answertable_1_1(
	answer_number varchar(10) not null,
	answer_option number(2) not null,
	constraint opt_check check (answer_option <= 5 and answer_option > 0),
	primary key (answer_number));
/* Multiple Choice Multiple Answer */
/* Positive values denote a selected choice */
drop table answertable_1_2;
create table answertable_1_2(
	answer_number varchar(10) not null,
	primary key(answer_number),
	answer_1	char(1),
	answer_2	char(1),
	answer_3	char(1),
	answer_4	char(1),
	answer_5	char(1));
/* Range Type Question		*/
drop table answertable_1_3;
create table answertable_1_3(
	answer_number varchar(10) not null,
	answer_value number(10,2) not null,
	primary key(answer_number));
/* Descriptive		*/
drop table answertable_1_4;
create table answertable_1_4(
	answer_number varchar(10) not null,
	answer_text varchar(100) not null,
	primary key (answer_number));
