import java.io.*;
import java.util.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class CreatorSession{

	static final String FormAction = "x";
	static final String FormMethod = "x";
	static final String FormDescrip = "formdes";
	static final String initFormID = "initForm";
	static final String createFormID = "creatForm";
	static final String updateFormID = "updatForm";
	static final String delFormID = "delForm";
	static final String updateQues = "updateQues";
    static final String DelQues = "delQues";
    static final String QuesType = "quesType";
    static final String QuesOptions = "quesOptions";
	static final String submitFormID = "subForm";
	static final int MulTypeSinAns = 1;
	static final int MulTypeMulAns = 2;
	static final int RanType = 3;
	static final int SubType = 4;
	static final String FormTableName = "forms";
	static final String QuestionTableName = "question_table";
	static final String AnswerTableName = "answer_table";
	static final String StudentTableName = "student_table";
	static final int QuestTypeCol = 3;
	static final int QuestTextCol = 4;
	static final int NoOpsCol = 5;
	static final int MaxNoOps = 5;
	static final int RanLowCol = NoOpsCol + MaxNoOps + 1;
	static final int RanUpCol = RanLowCol + 1;
	static final int AnswerTableCol = RanUpCol + 1;
	static final int RanSize = 4;
	static final int RanMaxLen = 8;
	static final int MaxRows = 5;
	static final int MaxCols = 20;
	static final String Rel_day = "rel_day";
	static final String Rel_month = "rel_month";
	static final String Rel_year = "rel_year";
	static final String Fill_day = "fill_day";
	static final String Fill_month = "fill_month";
	static final String Fill_year = "fill_year";
	static final String Anon_Sel = "anon_sel";
	static final String QuestionEditID = "QuestionEditID";
	static final String QuestionType = "QuestionType";
	static final String UpdateQuestionID = "UpdateQuestion";
	static final int MaxQTextLength=100;
	static final int MaxOTextLength=10;


	Connection conn;
	PrintWriter out;
	HttpServletRequest req;

//constructors

	public CreatorSession(Connection c, PrintWriter p, HttpServletRequest r){
		conn = c;
		out = p;
		req = r;
	}
	

	public void InitForm()
	throws SQLException{
		FormEdit fe = new FormEdit(conn, out);
		String FormNo = fe.initForm();
	}

//this function is invoked when the user enters the form_description
//its releasedate and filldate and presses submit.

	public void ProcessInit() throws SQLException{
		String ftext="", RelDate="", FillDate="", AnonSel="", formno="";
		try{
		ftext = req.getParameterValues(FormDescrip)[0];
		RelDate = req.getParameterValues(Rel_day)[0];
		RelDate = RelDate + "-" +req.getParameterValues(Rel_month)[0] + "-" + req.getParameterValues(Rel_year)[0];
		FillDate = req.getParameterValues(Fill_day)[0];
		FillDate = FillDate + "-" +req.getParameterValues(Fill_month)[0] + "-" + req.getParameterValues(Fill_year)[0];
		AnonSel = req.getParameterValues(Anon_Sel)[0];
		formno = req.getParameterValues("form_number")[0];
		}catch(NullPointerException e){
		}
		FormEdit fe = new FormEdit(conn, out, formno);
		fe.recvInit(ftext, RelDate, FillDate, AnonSel);
	}

//this function is called when the user presses the create question button
//in the form editor menu.
	public void ProcessCreate() throws SQLException{
		String type = req.getParameterValues(QuesType)[0];
		String options = req.getParameterValues(QuesOptions)[0];
		String FormNo = req.getParameterValues("form_number")[0];
		boolean sfsg = true;
		Integer ntype = new Integer(0);
		Integer nop = new Integer(0);
		try{
			ntype = new Integer(type);
			nop = new Integer(options);
		}catch(NumberFormatException e){
			out.println("<H2>Type and number of options should be integers.</H2>");
			sfsg = false;
		}
		if(sfsg){
			FormEdit fe = new FormEdit(conn, out, FormNo);
			fe.recvAddQuestion(ntype.intValue(), nop.intValue());
		}
	}

//this function is called when the delete question form is submitted on
//the main form edit menu

	public void ProcessDelete() throws SQLException{
		boolean sfsg = true;
		String formno = req.getParameterValues("form_number")[0];
		String Qno = req.getParameterValues(DelQues)[0];
		Integer qno = new Integer(0);
		try{
			qno = new Integer(Qno);
		}catch(NumberFormatException e){
			out.println("<H2>Question number should be an integer.</H2>");
			sfsg = false;
		}
		if(sfsg){
			FormEdit fe = new FormEdit(conn, out, formno);
			fe.recvDelQuestion(qno.intValue());
		}
	}

//this function is called when the update form is submitted in the main
//form menu.

	public void ProcessUpdate() throws SQLException{
		boolean sfsg = true;
		String formno = req.getParameterValues("form_number")[0];
		String Qno = req.getParameterValues(updateQues)[0];
		Integer qno = new Integer(0);
		try{
			qno = new Integer(Qno);
		}catch(NumberFormatException e){
			out.println("<H2>Question number should be an integer.</H2>");
			sfsg = false;
		}
		if(sfsg){
			FormEdit fe = new FormEdit(conn, out, formno);
			fe.recvUpdateQuestion(qno.intValue());
		}
	}

//this function is called when the main submit button is pressed in the
//main form menu.

	public void ProcessFinalSubmit() throws SQLException{
		String formno = req.getParameterValues("form_number")[0];
		FormEdit fe = new FormEdit(conn, out, formno);
		fe.recvQSubmit();
	}
//this function is called when the intermediate update form is submitted.

	public void ProcessInterMediateUpdate() throws SQLException{
		boolean sfsg = true;
		String formno = req.getParameterValues("form_number")[0];
		String qtext = req.getParameterValues("QText")[0];
		String qtype = req.getParameterValues("qtype")[0];
		String Qno = req.getParameterValues("qno")[0];
		Integer type = new Integer(0);
		Integer qno = new Integer(0);
		try{
			type = new Integer(qtype);
			qno = new Integer(Qno);
		}catch(NumberFormatException e){
			out.println("<H2>Question type and question number are not integers.</H2>");
			sfsg = false;
		}
		if(sfsg){
			FormEdit fe = new FormEdit(conn, out, formno);
			switch(type.intValue()){
				case MulTypeSinAns:
				case MulTypeMulAns:{
					String nop = req.getParameterValues("no_ops")[0];
					Integer t = new Integer(0);
					try{
						t = new Integer(nop);
					}catch(NumberFormatException e){
						out.println("<H2>No of options is not an integer.</h2>");
						sfsg = false;
					}
					if(sfsg){
						String temp[] = new String[t.intValue()];
						for(int i=1;i<=t.intValue();i++){
							temp[i-1] = req.getParameterValues("OP"+i+"TEXT")[0];
						}
						fe.recvEAddQuestion(qno.intValue(), qtext, temp, type.intValue());
					}
					break;
				}
				case RanType:{
					String Ul = req.getParameterValues("UBound")[0];
					String Ll = req.getParameterValues("LBound")[0];
					Double ul = new Double(0);
					Double ll = new Double(0);
					try{
						ul = new Double(Ul);
						ll = new Double(Ll);
					}catch(NumberFormatException e){
						out.println("<H2>upper and lower limits must be numbers.</H2>");
						sfsg = false;
					}
					if(sfsg){
						fe.recvEAddQuestion(qno.intValue(), qtext, ll.doubleValue(), ul.doubleValue());
					}
					break;
				}
				case SubType:{
					fe.recvEAddQuestion(qno.intValue(), qtext);
					break;
				}
				default:{
					out.println("<H2>unknown question type.</H2>");
				}
			}
		}
	}
public void ProcessInterMediateInsert() throws SQLException{
		boolean sfsg = true;
		String formno = req.getParameterValues("form_number")[0];
		String qtext = req.getParameterValues("QText")[0];
		String qtype = req.getParameterValues(QuestionType)[0];
		Integer type = new Integer(0);
		try{
			type = new Integer(qtype);
		}catch(NumberFormatException e){
			out.println("<H2>Question type is not integer.</H2>");
			sfsg = false;
		}
		if(sfsg){
			FormEdit fe = new FormEdit(conn, out, formno);
			switch(type.intValue()){
				case MulTypeSinAns:
				case MulTypeMulAns:{
					String nop = req.getParameterValues("no_ops")[0];
					Integer t = new Integer(0);
					try{
						t = new Integer(nop);
					}catch(NumberFormatException e){
						out.println("<H2>No of options is not an integer.</h2>");
						sfsg = false;
					}
					if(sfsg){
						String[] temp = new String[t.intValue()];
						for(int i=1;i<=t.intValue();i++){
							temp[i-1] = req.getParameterValues("OP"+i+"TEXT")[0];
						}
						fe.recvEAddQuestion(qtext, temp, type.intValue());
					}
					break;
				}
				case RanType:{
					String Ul = req.getParameterValues("UBound")[0];
					String Ll = req.getParameterValues("LBound")[0];
					Double ul = new Double(0);
					Double ll = new Double(0);
					try{
						ul = new Double(Ul);
						ll = new Double(Ll);
					}catch(NumberFormatException e){
						out.println("<H2>upper and lower limits must be numbers.</H2>");
						sfsg = false;
					}
					if(sfsg){
						fe.recvEAddQuestion(qtext, ll.doubleValue(), ul.doubleValue());
					}
					break;
				}
				case SubType:{
					fe.recvEAddQuestion(qtext);
					break;
				}
				default:{
					out.println("<H2>unknown question type.</H2>");
				}
			}
		}
	}

		
	
}	
