//this class generates a html form for the actual form with form number
//FormNo in the database represented by the connection conn.

import java.io.*;
import java.sql.*;
import java.util.*;


public class FormGen{

//some sort of JAVA macros
	static final int MulTypeSinAns = 1;
	static final int MulTypeMulAns = 2;
	static final int RanType = 3;
	static final int SubType = 4;
	static final int QuestTypeCol = 3;
	static final int QuestTextCol = 4;
	static final int NoOpsCol = 5;
	static final int MaxNoOps = 5;
	static final int RanLowCol = NoOpsCol + MaxNoOps + 1;
	static final int RanUpCol = RanLowCol + 1;
	static final int AnswerTableCol = RanUpCol + 1;
	static final int RanSize = 4;
	static final int RanMaxLen = 8;
	static final int MaxRows = 5;
	static final int MaxCols = 20;
//	static final int SubMaxRows = 5;
//	static final int SubMaxCols = 20;
	static final String FormTableName = "forms";
	static final String QuestionTableName = "question_table";
	static final String AnswerTableName = "answer_table";
	static final String StudentTableName = "student_table";
	static final int Port=5015;
	static final String FormAction = "\"http://everest.cse.iitb.ernet.in:"+Port+"/servlet/MainServlet\"";
	static final String FormMethod = "\"post\"";


//global data.
	Connection conn;
	String FormNo;
	RandomAccessFile OutputFile;
	boolean OutputFileDefined = false;
	Random rand = new Random();
	String LoginId,PassWd;
	PrintWriter Out;

//some flags
	
	//default constructor
	public FormGen(){};

	//other constructors

//constructor to write to a file.
	public FormGen(PrintWriter outfile, Connection c, String formno, String log_id, String passwd)
	throws SQLException{
		Out = outfile;
		OutputFileDefined = true;
		FormNo = formno;
		LoginId = log_id;
		PassWd = passwd;
		conn = c;

	}
//constructor to write to stdout.
	public FormGen(String formno, String log_id, String passwd)
	throws SQLException{
		FormNo = formno;
		LoginId = log_id;
		PassWd = passwd;
	    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    	Connection conn = DriverManager.getConnection ("jdbc:oracle:thin:@:1521:GEN", "jatin", "tiger");
	}

	
	//decide access later

	private void println(String S){
		if(OutputFileDefined) Out.println(S);
		else System.out.println(S);
	}

	private void print(String S){
		if(OutputFileDefined)Out.print(S);
		else System.out.print(S);
	}

	private void err(String S){
		System.out.println("Error:" + S);
	}

	private int getRand(){
		return rand.nextInt();
	}

	private boolean CheckFillDate()
	throws SQLException{
		java.util.Date date = new java.util.Date();
		String FillDate = "";
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select TO_CHAR(fill_date,'DD-MM-YY') from "+FormTableName+" where form_number='"+FormNo+"'");
			while(rset.next()) FillDate = rset.getString(1);
			stmt.close();
		}catch(SQLException e){err("could not read fill date");}
		MyDate Today = new MyDate(FillDate);
		boolean res = Today.JavaDate.after(date);
		if(!res) println("<H2>The last date for filling this form has passed.</H2>");
		return res;
	}

	private boolean CheckFormNo() throws SQLException{
		boolean res = false;
		String temp = "";
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select state from "+FormTableName+" where form_number='"+FormNo+"'");
			res = rset.next();
			temp = rset.getString(1);
			stmt.close();
		}catch(SQLException e){err("could not find form no:"+FormNo);}
		if(!res) println("<H2>ERROR:No form with number :"+FormNo+"</H2>");
		else if(!temp.equals("F")){
			res = false;
			println("<H2>This form is under construction or deleted.</H2>");
		}
		
		return res;
	}


	private boolean CheckAccess(){
		boolean res = false;
		String temp = "";
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select valid from "+StudentTableName+" where login_id='"+LoginId+"' and form_number='"+FormNo+"'");
			res = rset.next();
			temp = rset.getString(1);
		}catch(SQLException e){
			println("<H2>"+LoginId+": No such user in database.</H2>");
			res = false;
		}
		if(res){
			if(temp.equals("Y")) res = true;
			else{ 
				println("<H2>Error: you have already filled this form.</H2>");
				res = false;
			}
		}
		return res;
	}

	public void Generate()
	throws SQLException{
	  	if(CheckFormNo() && CheckFillDate() && CheckAccess()){
			int NoQuestions = 0;
			Statement stmt = conn.createStatement();
			ResultSet rset;
//Analyzing question table.
			try{
				rset = stmt.executeQuery("select count(*) from "+QuestionTableName+" where form_number='"+FormNo+"'");
				while(rset.next()) NoQuestions = rset.getInt(1);
			}catch(SQLException e){
				err("could not read no of questions");
			}

			String Head = "";
			try{
				rset = stmt.executeQuery("select description from "+FormTableName+" where form_number='"+FormNo+"'");
				while(rset.next())Head = rset.getString(1);
				stmt.close();
			}catch(SQLException e){
				err("could not read description from database");
			}
			println("<CENTER><H1>"+Head+"</CENTER></H1>");
			int i;
//headers
//currently give the output to stdout.
//to change output destination change functions print and println.
			println("<FORM ACTION="+FormAction+" METHOD="+FormMethod+">");
//add cookie.
//add form number for later processing.
			println("<INPUT TYPE='HIDDEN' NAME='form_number' VALUE='"+FormNo+"'>");
			println("<INPUT TYPE='HIDDEN' NAME='form_id' VALUE='form_filler_submission'>");
		
//generate questions.
			for(i=1;i<=NoQuestions;i++)
				GenQuestion(i);
//submit and reset buttons.
			println("<INPUT TYPE=SUBMIT VALUE=SUBMIT><INPUT TYPE=RESET VALUE='CLEAR FORM'>");
			println("</FORM>");
	  	}
	}


//This function generates a single question corresponding to the parameter Qno
//from the table represented by TabName.
	private void GenQuestion(int Qno)
	throws SQLException{
		int i;		
		try{
			Statement stmt = conn.createStatement();
//Select the row corresponding to Qno
			ResultSet rset = stmt.executeQuery("select * from "+QuestionTableName+" where question_number="+Qno+" and form_number='"+FormNo+"'");
//Print the question.
			while(rset.next()){
				println("Q "+Qno+") "+rset.getString(QuestTextCol)+"<BR>");
				switch(rset.getInt(QuestTypeCol)){
//multiple choice single answer type questions.
				case MulTypeSinAns: {
					println("<SELECT NAME='question_"+Qno+"'><BR>");
					for(i=0;i<rset.getInt(NoOpsCol);i++)
						println("<OPTION VALUE='"+(i+1)+"'>"+rset.getString(NoOpsCol+1+i));
					println("</SELECT><BR>");
					break;
				}
//multiple choice multiple answer type questions.
				case MulTypeMulAns: {
					for(i=0;i<rset.getInt(NoOpsCol);i++)
						println("<INPUT TYPE='CHECKBOX' NAME='question_"+Qno+"' VALUE='"+(i+1)+"'>"+rset.getString(NoOpsCol+1+i)+"&nbsp;");
						println("<BR>");
					break;
				}
//range wala --right now i have no idea how to implement this.
				case RanType: {
					println("<INPUT TYPE='TEXT' NAME='question_"+Qno+"' SIZE='"+RanSize+"' MAXLENGTH='"+RanMaxLen+"'><BR>");
					break;
				}
//subjective type question

				case SubType: {
					println("<TEXTAREA NAME='question_"+Qno+"' ROWS='"+MaxRows+"' COLS='"+MaxCols+"' ma></TEXTAREA><BR>");
					break;
				}
				default: {
					println("No question of type "+rset.getString(QuestTypeCol));
				}
			}
		}
		stmt.close();

		}catch(SQLException e){
			err("could not read form table");
		}
	}

}
	
