import java.io.*;
import java.lang.*;
import java.sql.*;
import java.util.*;

//this class gives statistics of the form with form number FormNo
//and database represented by conn.
//TODO add a function which gives output form by form --is this needed?
//TODO unnecessary options are also printed in histogram. 

class FormStat{


	final static String FormTableName = "forms";
	final static String QuestionTableName = "question_table";
	final static String AnswerTableName = "answer_table";
	String FormNo;
	private Connection conn;
	PrintWriter out;
	boolean OutputFileDefined = false;

//constructor
	public FormStat(Connection connect, String formno){
		conn = connect;
		FormNo = formno;
	}
	public FormStat(PrintWriter o, Connection connect, String formno){
		out = o;
		OutputFileDefined = true;
		conn = connect;
		FormNo = formno;
	}


	private boolean CheckReleaseDate()
	throws SQLException{
		java.util.Date date = new java.util.Date();
		String RelDate = "";
		try{
			Statement stmt = conn.createStatement();
        	ResultSet rset = stmt.executeQuery("select TO_CHAR(release_date,'DD-MM-YY') from "+FormTableName+" where form_number='"+FormNo+"'");
        	while(rset.next()) RelDate = rset.getString(1);
			stmt.close();
        	MyDate Today = new MyDate(RelDate);
        	return Today.JavaDate.before(date);
		}catch(SQLException e){
			err("Could not read release date.");
			return false;
		}
    }

	public void ShowStats()
	throws SQLException{
	  	if(CheckReleaseDate()){
			int type=0,qno,NoQuests=0;
			try{
				Statement stmt = conn.createStatement();
				ResultSet rset = stmt.executeQuery("select description from "+FormTableName+" where form_number='"+FormNo+"'");
				while(rset.next()){
					println("<H1>Statistics for "+rset.getString(1)+"</H1>");
				}
		
//find out the number of questions.
				try{
					rset = stmt.executeQuery("select count(*) from "+QuestionTableName+" where form_number='"+FormNo+"'");
					while(rset.next()) NoQuests = rset.getInt(1);
				}catch(SQLException e){
					err("could not read no. of questions");
				}

				for(qno=1;qno <= NoQuests;qno++){
				PrintQuestText(qno);
					try{
						rset = stmt.executeQuery("select question_type from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
						while(rset.next()) type = rset.getInt(1);
					}catch(SQLException e){
						err("could not read question type.");
					}
					switch(type){
						case 1:{
							ShowStatsMulTypeSinAns(qno);
							break;
						}
						case 2:{
							ShowStatsMulTypeMulAns(qno);
							break;
						}
						case 3:{
							ShowStatsRangeType(qno);
							break;
						}
						case 4:{
							ShowStatsSubjType(qno);
							break;
						}
						default:{
							err("Invalid question type in table" + QuestionTableName);
						}
					}
				}
				stmt.close();
			}catch(SQLException e){
				err("Could not read form description");
			}
	  	}
	  	else println("<H2>The statistics for this form are not released yet.</H2>");
	}

//currently these functions just give out the answers and trivial stuff.
//more pseud things to be added later;

	private void ShowStatsMulTypeSinAns(int qno)
	throws SQLException{
		int NoOps = 5, count = 0;
//The arrays val and name is used for histogram display.
		int val[] = new int[NoOps];
		String name[] = new String[NoOps];
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset;
			for(count=1;count<=NoOps;count++){ 
				rset = stmt.executeQuery("select option_"+count+" from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
				while(rset.next()){
					name[count-1] = rset.getString(1);
//				print(name[count-1]+":");
				}
				rset = stmt.executeQuery("select count(answer_option) from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number="+qno+" and answer_option="+count);
				while(rset.next()){
					val[count-1] = rset.getInt(1);
//				println(val[count-1]+"");
				}
			}
			stmt.close();
			HistoGramGen hist = new HistoGramGen(out,val, name);
			hist.DrawHistoGram();
		}catch(SQLException e){
			err("could not get values for qno"+qno);
		}
	}

	private void ShowStatsMulTypeMulAns(int qno)
	throws SQLException{
		int NoOps = 5,count = 0;
//The arrays val and name is used for histogram display.
		int val[] = new int[NoOps];
		String name[] = new String[NoOps];
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset;
			for(count=1;count<=NoOps;count++){
				rset = stmt.executeQuery("select option_"+count+" from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
				while(rset.next()){
					name[count-1] = rset.getString(1);
//				print(name[count-1]+":");
				}
				rset = stmt.executeQuery("select count(mult_"+count+") from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number="+qno+" and mult_"+count+"='Y'");
				while(rset.next()){
					val[count-1] = rset.getInt(1);
//				println(val[count-1]+"");
				}
			}
			stmt.close();
			HistoGramGen hist = new HistoGramGen(out, val, name);
			hist.DrawHistoGram();
		}catch(SQLException e){
			err("could not read values for qno:"+qno);
		}
	}
		
			
//TODO store the individual double value for other statistics.
	private void ShowStatsRangeType(int qno)
	throws SQLException{
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select avg(answer_value) from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number="+qno);
			while(rset.next()) println("Average value = <B>"+rset.getDouble(1)+"</B><BR><BR>");
			stmt.close();
		}catch(SQLException e){
			err("could not get avg value for qno:"+qno);
		}
	}


	private void ShowStatsSubjType(int qno)
	throws SQLException{
		try{
			int NoAns=0;
			Statement stmt = conn.createStatement();
			ResultSet rset;
			rset = stmt.executeQuery("select answer_text from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number="+qno);
			while(rset.next()) println(rset.getString(1)+"<BR><HR ALIGN=LEFT WIDTH=75%>");
			stmt.close();
		}catch(SQLException e){
			err("could not read text for qno:"+qno);
		}
	}


	private void PrintQuestText(int qno)
	throws SQLException{
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select question_text from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
			while(rset.next()) println("<B>Q "+qno+")" + rset.getString(1)+"</B><BR>");
			stmt.close();
		}catch(SQLException e){
			err("could not read question text for qno:"+qno);
		}
	}

	private void print(String S){
		if(OutputFileDefined) out.print(S);
		else System.out.print(S);
	}

	private void println(String S){
		if(OutputFileDefined) out.println(S);
		else System.out.println(S);
	}

	private void err(String S){
		System.out.println("FormStat: "+S);
	}

}

