import java.io.*;

public class HistoGramGen{

	static final int MaxNoCols = 40;
	static final String HistStr = new String("#");
	static final String NonHistStr = new String("_");
	int NameCols;
	int values[];
	String names[];
	int NoVals;
	int MaxVal;
	int MaxNameLen;
	PrintWriter out;
	boolean OutputDefined = false;

//constructor

	public HistoGramGen(int val[], String name[]){
		if(val.length != name.length) err("No. of vals != no. of names");
		else{
			NoVals = val.length;
			MaxVal = 0;
			MaxNameLen = 0;
			values = new int[NoVals];
			names = new String[NoVals];
			for(int i=0;i<NoVals;i++){
				values[i] = val[i];
				if(val[i] > MaxVal) MaxVal = val[i];
				names[i] = name[i];
				if(name[i].length() > MaxNameLen) MaxNameLen = name[i].length();
			}
		}
	}

	public HistoGramGen(PrintWriter o,int val[], String name[]){
		if(val.length != name.length) err("No. of vals != no. of names");
		else{
			out = o;
			OutputDefined = true;
			NoVals = val.length;
			MaxVal = 0;
			MaxNameLen = 0;
			values = new int[NoVals];
			names = new String[NoVals];
			for(int i=0;i<NoVals;i++){
				values[i] = val[i];
				if(val[i] > MaxVal) MaxVal = val[i];
				names[i] = name[i];
				if(name[i].length() > MaxNameLen) MaxNameLen = name[i].length();
			}
		}
	}

	public void DrawHistoGram(){
		int i,j,k;
		double scale = (double)MaxNoCols/(double)MaxVal;
		for(i=0;i<NoVals;i++){
			j = (int)((double)values[i]*scale);
			print(names[i]);
			for(k=0;k<MaxNameLen-names[i].length();k++) print(NonHistStr);
			print(":");
			for(k=0;k<j;k++) print(HistStr);
			for(k=j;k<MaxNoCols;k++)print(NonHistStr);
			println(values[i]+"<BR>");
		}
		println("<BR>");
	}

	private void err(String S){
		System.out.println("HistoGramGen:"+S);
	}

	private void print(String S){
		if(OutputDefined)out.print(S);
		else System.out.print(S);
	}

	private void println(String S){
		if(OutputDefined)out.println(S);
		else System.out.println(S);
	}
}
