import java.io.*;

//this class prints the defaults on all the pages which form a part
//of the feedback process.

public class HtmlDefaultPrinter{

//some properties of the web pages sent as outputs to requests.
	String Title = "";
	String BgColor = "\"#FFFFFF\"";
	String TextColor = "\"#000000\"";
	String VlinkColor = "\"#FF0000\"";
	String LinkColor = "\"#00FF00\"";
	String AlinkColor = "\"#0000FF\"";
//output Writer to write to.
	PrintWriter out;
//flag used to determine output target (out or stdout).
	boolean OutputDefined = false;

//constructors

	public HtmlDefaultPrinter(PrintWriter o){
		out = o;
		OutputDefined = true;
//default title.
		Title = "The Feedback Network";
	}
	
	public HtmlDefaultPrinter(PrintWriter o, String title){
		out = o;
		OutputDefined = true;
		Title = title;
	}

	public HtmlDefaultPrinter(PrintWriter o , String title, String bg, String text, String link, String alink, String vlink){
		out = o;
		OutputDefined = true;
		Title = title;
		BgColor = bg;
		TextColor = text;
		LinkColor = link;
		AlinkColor = alink;
		VlinkColor = vlink;
	}

//generic output function which writes to stdout or out depending on 
//OutputDefined
	private void print(String S){
		if(OutputDefined) out.print(S);
		else System.out.print(S);
	}

//generic output function which writes to stdout or out depending on 
//OutputDefined
	private void println(String S){
		print(S+"\n");
	}

//debugging function.
	private void err(String S){
		System.err.println("HtmlDefaultPrinter:"+S);
	}
	
//this function prints the default headers.
	public void PrintHeaders(){
		out.print("<HTML>\n<HEAD>\n\t<TITLE>");
		out.println(Title+"</TITLE>\n</HEAD>");
		out.print("<BODY BGCOLOR="+BgColor+" TEXT="+TextColor);
		out.print(" LINK="+LinkColor+" VLINK="+VlinkColor);
		out.println(" ALINK="+AlinkColor+">");
	}

//this function prints the default tail in all web pages.
	public void PrintEnd(){
		out.println("<HR WIDTH=100%><BR>");
		out.println("<FONT SIZE=-1><A HREF=\"http://www.cse.iitb.ernet.in/~kinit/bis/index.html\">Main</A>");
		out.println("<b>|</b><a href=\"http://everest.cse.iitb.ernet.in:5015/servlet/MainServlet?form_id=generate_filler_login\">Give Feedback</a>");
		out.println("<b>|</b><a href=\"http://everest.cse.iitb.ernet.in:5015/servlet/MainServlet?form_id=generate_overallstat_form\">Overall Statistics</a>");
		out.println("<b>|</b><a href=\"http://everest.cse.iitb.ernet.in:5015/servlet/MainServlet?form_id=generate_singlestat_form\">Filled Forms</a>");
		out.println("</font>");
		out.println("</BODY></HTML>");
	}
}
