import java.io.*;
import java.util.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

//this is the one and only servlet which handles all requests.
//it distinguishes its requests by looking at a field "form_id" in
//its requests and takes the corresponding course of action.
public class MainServlet extends HttpServlet{

//conn is the variable which represents the connection to the database.
	Connection conn;

//some helpful macros
	final static String CreatorTableName = "creator_table";
	static final String FormAction = "x";
	static final String FormMethod = "x";
	static final String FormDescrip = "formdes";
	static final String initFormID = "initForm";
	static final String createFormID = "creatForm";
	static final String updateFormID = "updatForm";
	static final String delFormID = "delForm";
	static final String updateQues = "updateQues";
    static final String DelQues = "delQues";
    static final String QuesType = "quesType";
    static final String QuesOptions = "quesOptions";
	static final String submitFormID = "subForm";
	static final int MulTypeSinAns = 1;
	static final int MulTypeMulAns = 2;
	static final int RanType = 3;
	static final int SubType = 4;
	static final String FormTableName = "forms";
	static final String QuestionTableName = "question_table";
	static final String AnswerTableName = "answer_table";
	static final String StudentTableName = "student_table";
	static final int QuestTypeCol = 3;
	static final int QuestTextCol = 4;
	static final int NoOpsCol = 5;
	static final int MaxNoOps = 5;
	static final int RanLowCol = NoOpsCol + MaxNoOps + 1;
	static final int RanUpCol = RanLowCol + 1;
	static final int AnswerTableCol = RanUpCol + 1;
	static final int RanSize = 4;
	static final int RanMaxLen = 8;
	static final int MaxRows = 5;
	static final int MaxCols = 20;
	static final String Rel_day = "rel_day";
	static final String Rel_month = "rel_month";
	static final String Rel_year = "rel_year";
	static final String Fill_day = "fill_day";
	static final String Fill_month = "fill_month";
	static final String Fill_year = "fill_year";
	static final String Anon_Sel = "anon_sel";
	static final String QuestionEditID = "QuestionEditID";
	static final String QuestionType = "QuestionType";
	static final String UpdateQuestionID = "UpdateQuestion";
	static final int MaxQTextLength=100;
	static final int MaxOTextLength=10;



//what this servlet should do at startup is done in this function.
//here it establishes a connection to the database.
	public void init(ServletConfig cfg)
	throws ServletException{
	try{
		DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
//the protocol,  username and password are system specific and should
//be changed according to your Oracle config.
		conn = DriverManager.getConnection ("jdbc:oracle:thin:@:1521:GEN", "kinit", "tinjaka");
	}catch(SQLException e){System.err.println("could not connect to database");}
	}


//this method is invoked when a form calls this servlet with the
//POST method.
	public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException{
		try{
//out stands for the output to write to. 
			PrintWriter out = res.getWriter();
//setting contennt type of the response.
			res.setContentType("text/html");
//Printing the default headers of the output given as response.
			HtmlDefaultPrinter ht = new HtmlDefaultPrinter(out);
			ht.PrintHeaders();
//determining where the response came from
			String FormId = "";
//flag used to check if form_id is present in the request or not.
			boolean FormIdOk = true;
			try{
				FormId = req.getParameterValues("form_id")[0];
			}catch(NullPointerException e){
//if form_id is not present in the request then print error and exit.
				out.println("<H2>Error: Invalid Form_id.</H2>");
				FormIdOk=false;
			}
			if(FormIdOk){


			if(FormId.equals("form_creator_login")){
//code for handling requests from a form_creator to login.

				String login = req.getParameterValues("login_id")[0];
				String pass = req.getParameterValues("passwd")[0];
//check login and passwd. if correct, start a session.
				CreatorAuth ct = new CreatorAuth(conn, login, pass, CreatorTableName);
				if(ct.AuthUser()){
					HttpSession session = req.getSession(true);
					session.putValue("login_id", login);
					session.putValue("access_type","form_creator");
//invoke creator class.
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.InitForm();
				}
//wrong passwd buddy.
				else{
					out.println("<H2>Error: Incorrect login or password</h2>");
				}
					
			}
			else if(FormId.equals(initFormID)){
				HttpSession session = req.getSession(false);
				if(session == null){
					out.println("<H2>Login First and enable cookies.</H2>");
				}
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessInit();
				}
			}
			else if(FormId.equals(createFormID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessCreate();
				}
			}
			else if(FormId.equals(delFormID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessDelete();
				}
			}
			else if(FormId.equals(updateFormID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessUpdate();
				}
			}
			else if(FormId.equals(QuestionEditID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessInterMediateInsert();
				}
			}
			else if(FormId.equals(UpdateQuestionID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessInterMediateUpdate();
				}
			}
			else if(FormId.equals(submitFormID)){
				HttpSession session = req.getSession(false);
				if(session == null) out.println("<H2>Login First and enable cookies.</H2>");
				else{
					CreatorSession cs = new CreatorSession(conn, out, req);
					cs.ProcessFinalSubmit();
				}
			}
			else if(FormId.equals("generate_filler_login")){
//code to generate the initial login form shown to people who will give
//feedback.
				GenerateFillerLogin gf = new GenerateFillerLogin(conn, out);
				gf.Generate();
			}
			else if(FormId.equals("generate_overallstat_form")){
//code to generate form which is to be filled for overall statistics.
				OverAllStatFormGenerate ovt = new OverAllStatFormGenerate(conn, out);
				ovt.Generate();
			}
			else if(FormId.equals("show_overall_stats")){
//code to handle requests for overall statistics
				String form_num = req.getParameterValues("form_number")[0];
				FormStat fst = new FormStat(out, conn, form_num);
				fst.ShowStats();
			}
			else if(FormId.equals("generate_singlestat_form")){
//code to generate form which is to be filled for single form statistics.
				SingleStatFormGenerate sgt = new SingleStatFormGenerate(conn, out);
				sgt.Generate();
			}
			else if(FormId.equals("show_single_stats")){
//code to show single form statistics.
				SingleStat sss = new SingleStat(conn, out, req);
				sss.ShowStats();
			}
			else if(FormId.equals("form_filler_login")){
//code to process login information of form filler.
//login gets the entered login name and pass gets the entered password.
				String login = req.getParameterValues("login_id")[0];
				String pass = req.getParameterValues("passwd")[0];
//form_num gets the form number for which the user is going to give
//feedback
				String form_num = req.getParameterValues("form_number")[0];
//authenticate the user.
				Auth at = new Auth(conn, login, pass, StudentTableName, form_num);
				if(at.AuthUser()){
//if authenticated, the associate a session to the request and add
//additional info for recognizing later requests.
					HttpSession session = req.getSession(true);
					session.putValue("login_id", login);
					session.putValue("access_type","form_filler");
//call Form Generator class to generate the feedback form.
					FormGen gen = new FormGen(out, conn, form_num, login, pass);
					gen.Generate();
				}
				else{
//if not authorised then ditch him.
					out.println("<h2>Incorrect username or password.</h2>");
				}
			}
			else if(FormId.equals("form_filler_submission")){
//code for processing feedback submitted by users.
//first check that there is a session associated with the request.
				HttpSession session = req.getSession(false);
//if no session is associated then show error.
				if(session == null) out.println("<h2>Please login first.</h2>");
				else{
//if a session is associated then extract login_id from the session
//and pass the request to the updating class.
					String login = (String)(session.getValue("login_id"));
					FillerUpdateSession fus = new FillerUpdateSession(conn, req, out, login);
					fus.Update();
				}
			}
			else{
//if form_id is some junk show error.
				out.println("<h2>There is an internal error in the form you submitted. Make sure you filled the form at the feedback site itself.");
			}
//close of if(formidok)
		}
//print default tail of html document
			ht.PrintEnd();
//close output
			out.close();
		}catch(SQLException e){}
	}


//this method gets invoked if a request is made to this servlet with
//the GET method. The actions are the same as doPost.
	public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException{
		doPost(req,res);
	}

//just for debugging purposes.
	private void err(String S){
		System.err.println(S);
	}
}
