import java.sql.*;
import java.io.*;


//this file outputs single forms given a form number and an answer no.
public class SingleFormOutput{

//global data and constants
	static final int MulTypeSinAns = 1;
	static final int MulTypeMulAns = 2;
	static final int RanType = 3;
	static final int SubType = 4;
	static final int QuestTypeCol = 3;
	static final int QuestTextCol = 4;
	static final int NoOpsCol = 5;
	static final int MaxNoOps = 5;
	static final int RanLowCol = NoOpsCol + MaxNoOps + 1;
	static final int RanUpCol = RanLowCol + 1;
	static final int AnswerTableCol = RanUpCol + 1;
	static final int RanSize = 4;
	static final int RanMaxLen = 8;
	static final int SubMaxRows = 5;
	static final int SubMaxCols = 20;
	static final String FormTableName = "forms";
	static final String QuestionTableName = "question_table";
	static final String AnswerTableName = "answer_table";
	static final String StudentTableName = "student_table";
	static final int QnoCol = 2;
	static final int OptCol = 4;
	static final int NoOps = 5;
	static final int ValCol = OptCol + NoOps + 1;
	static final int TextCol = ValCol + 1;
	static final String Port = "5015";
	static final String SinOPServletName = "http://everest.cse.iitb.ernet.in:"+Port+"/servlet/MainServlet";
	static final String Method = "\"post\"";
//data
	String FormNo;
	Connection conn;
	PrintWriter out;
	boolean OutputDefined = false;
	int AnsNo;
	
//constructors

	public SingleFormOutput(PrintWriter o, Connection c, String formno, int ansno){
		out = o;
		OutputDefined = true;
		conn = c;
		FormNo = formno;
		AnsNo = ansno;
	}
	
	public SingleFormOutput(Connection c, String formno, int ansno){
		conn = c;
		FormNo = formno;
		AnsNo = ansno;
	}

//This funtion takes a form number and an answer number and prints out
//answers to all questions in the form with the given form number with
//the given answer table. It reproduces the answers given to the nth
//feedback form. This feature is useful in cases like online exams.
	public void ShowForms()
	throws SQLException{
		try{
			int qno,type,totans=0;
			ResultSet ques,rset;
			Statement stmt = conn.createStatement();
			Statement s2 = conn.createStatement();
//get description for the form.
			String desc="";
			try{
				rset = stmt.executeQuery("select description from "+FormTableName+" where form_number='"+FormNo+"'");
				while(rset.next()) desc = rset.getString(1);
			}catch(SQLException e){
				err("could not read form description.");
			}
//determining who gave this particular answer.
			String name = "";
			try{
				rset = stmt.executeQuery("select login_id from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number='1' and answer_number='"+AnsNo+"'");
				while(rset.next()) name = rset.getString(1);
			}catch(SQLException e){
				err("could not read user info.");
			}
//determining total number of feedbacks given to the current form.
			try{
				rset = stmt.executeQuery("select count(*) from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number=1");
			while(rset.next()) totans = rset.getInt(1);
			}catch(SQLException e){
				err("could not read no of answers.");
			}
//get all the answers and print them out in a format depending on the 
//corresponding question type.
			rset = stmt.executeQuery("select * from "+AnswerTableName+" where form_number='"+FormNo+"' and answer_number="+AnsNo);
			ques = s2.executeQuery("select * from "+QuestionTableName+" where form_number='"+FormNo+"' order by question_number");
			println("<H1>Answer Set: "+(AnsNo)+" for <b><i>"+desc+"</i></b><BR>Answered by : <I>"+name+"</I></H1>");
			while(rset.next()){
//determine question number.
				qno = rset.getInt(QnoCol);
				PrintQuestion(qno);
				if(ques.next()){
					type = ques.getInt(QuestTypeCol);
					switch(type){
//printing answer for a question of the type Multiple choice single answer.
						case MulTypeSinAns:{
							println(ques.getString(NoOpsCol+rset.getInt(OptCol))+"<BR><BR>");
							break;
						}
//printing answer for a question of the type Multiple choice multiple answer.
						case MulTypeMulAns:{
							boolean flag=false;
							for(int i=1;i<=NoOps;i++){
								if(rset.getString(OptCol+i).equals("Y")){
									flag = true;
									println(ques.getString(NoOpsCol+i)+"<BR>");
								}
							}
							if(!flag){
								println("No answers selected.<BR>");
							}
							print("<BR>");
							break;
						}
//printing answer for a question of the type constrained.
						case RanType:{
							println(rset.getString(ValCol)+"<BR><BR>");
							break;
						}
//printing answer for a question of subjective type.
						case SubType:{
							println(rset.getString(TextCol)+"<BR><BR>");
							break;
						}
//error message for any other type.
						default:{
							err("Wrong question type encountered in database.");
						}
					}
				}
			}
//this block checks if the answer number is either the last or the first 
//in the database and provides links at the end of the database to access
//the previous and next answers and also to jump to any answer in the data
//base

//link to next answer set
			if(AnsNo < totans){
				println("<H3><A HREF=\""+SinOPServletName+"?answer_number="+(AnsNo+1)+"&form_id=show_single_stats&form_number="+FormNo+"\">Next Answer Set</A><BR>");
			}
//link to previous answer set
			if(AnsNo > 1){
				println("<A HREF=\""+SinOPServletName+"?answer_number="+(AnsNo-1)+"&form_id=show_single_stats&form_number="+FormNo+"\">Previous Answer Set</A><BR></H3>");
			}
//form which takes answer_number from the user directly.
			println("<FORM ACTION=\""+SinOPServletName+"\" METHOD="+Method+">");
			println("<INPUT TYPE='HIDDEN' NAME='form_id' VALUE='show_single_stats'>");
			println("Jump to answer set:<INPUT TYPE='TEXT' NAME='answer_number' SIZE=2 MAXLENGTH=5>(between 1 and "+totans+")");
			println("<INPUT TYPE='HIDDEN' NAME='form_number' VALUE='"+FormNo+"'>");
			println("<INPUT TYPE='SUBMIT' VALUE='Go!!'>");
			println("</FORM>");
			stmt.close();
			s2.close();
		}catch(SQLException e){
			err("could not access database.");
		}
	}


//this function takes a question number and a form number as parameters and
//prints the corresponding question.
	private void PrintQuestion(int qno){
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select question_text from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
			while(rset.next()) println("<B>"+rset.getString(1)+"</B><BR>");
			stmt.close();
		}catch(SQLException e){
			err("could not access database");
		}
	}
//generic print functions.
	private void print(String S){
		if(OutputDefined) out.print(S);
		else System.out.print(S);
	}
	
	private void println(String S){
		if(OutputDefined) out.println(S);
		else System.out.println(S);
	}
//debugging function.
	private void err(String S){
		System.err.println("SingleFormOutput:"+S);
	}
}
