import java.sql.*;
import java.io.*;

//This class updates the database after the class CheckInputFormat has
//checked the format of the feedback. It expects two arrays, one of
//question numbers and another of answer values.
//input parameters: connection to database, form number, arrays representing
//question numbers and corresponding values and login id of the user giving
//the feedback.
public class UpdateDB{

//some useful macros.
	static final int MulTypeSinAns = 1;
	static final int MulTypeMulAns = 2;
	static final int RanType = 3;
	static final int SubType = 4;
	static final int NoOps = 5;
	static final String FormTableName = "forms";
	static final String QuestionTableName = "question_table";
	static final String StudentTableName = "student_table";
	static final String AnswerTableName = "answer_table";
	
//length of "question_"
	static final int VarLen = 9;

//the parameters which will be initialised by the calling class.
	Connection conn;
	String FormNo;
	String Value[];
	String LoginId;
	String Name;
	Integer Qno[];
	PrintWriter out;
	boolean OutputDefined = false;

//constructors

	public UpdateDB(Connection c, String name[], String value[], String formno, String login){
		if(name.length != value.length)
			err("unequal array lengths. Exiting");
		else{
			conn = c;
			FormNo = formno;
			LoginId = login;
			Qno = new Integer[name.length];
			Value = new String[name.length];
			Name = "Anonymous";
			for(int i=0;i<name.length;i++){
				Qno[i] = new Integer(name[i].substring(VarLen,name[i].length()));
				Value[i] = value[i];
			}
		}
	}

	public UpdateDB(PrintWriter o, Connection c, String name[], String value[], String formno, String login){
		if(name.length != value.length)
			err("unequal array lengths. Exiting");
		else{
			out = o;
			OutputDefined = true;
			conn = c;
			FormNo = formno;
			LoginId = login;
			Name = "Anonymous";
			Qno = new Integer[name.length];
			Value = new String[name.length];
			for(int i=0;i<name.length;i++){
				Qno[i] = new Integer(name[i].substring(VarLen,name[i].length()));
				Value[i] = value[i];
			}
		}
	}


//this function does the actual database updating. It returns 0 on a
//successful update and a non-zero value otherwise.
	public int Update()
	throws SQLException{
		SetAnonymity();
		int AnsNo=0,i=0,j=0,type=0,oldQno=0,qno=0,result=0;
		String temp="",AllNo="";
		Integer t;
		Double d;
		String dd;
//Determining answer_number by adding one to the current max answer number
//in the database.
		Statement stmt = conn.createStatement();
		ResultSet rset = stmt.executeQuery("select count(*) from "+AnswerTableName+" where form_number='"+FormNo+"' and question_number=1");
		while(rset.next()) AnsNo=rset.getInt(1)+1;
		for(j=0;j<NoOps;j++) AllNo += "'N',";
		oldQno = 0;
//run through the array of question_numbers.
		for(i=1;i<=Qno.length;i++){
			qno= Qno[i-1].intValue();
//determine type of the given question number.
			type = GetType(qno);
//if type is invalid then show error.
			if(type == -1){
				err("Invalid type returned by GetType");
				result = 1;
			}
			else{ 

//if current answer number is the same as that of the previous question then
//the question should be of the multiple choice with more than one answer 
//type. else error.
				if(qno == oldQno){
					if(type != MulTypeMulAns){
						err("Repetition of non-mamc question.");
						result = 2;
					}
					else{    
//if the type is MulTypeMulAns then update the corresponding field in the
//answer table to indicate the choice.
						t = new Integer(Value[i-1]);
						stmt.executeUpdate("update "+AnswerTableName+" set mult_"+(t.intValue())+"='Y' where form_number='"+FormNo+"' and question_number="+qno+" and answer_number="+AnsNo);
					}
				}
				else{
//depending on the type of the question perform different inserts in the
//answer table./
					switch(type){
//processing multiple choice single answer type questions.
						case MulTypeSinAns:{
							if(Value[i-1].equals("")) t = new Integer("0");
							else t = new Integer(Value[i-1]);
							try{
								String sss = "insert into "+AnswerTableName+" values('"+FormNo+"',"+qno+","+AnsNo+","+t.intValue()+","+AllNo+"0,'junk','"+Name+"')";
								stmt.executeUpdate(sss);
//								stmt.executeUpdate("insert into "+AnswerTableName+" values('"+FormNo+"','"+qno+"','"+AnsNo+"',"+t.intValue()+","+AllNo+"0,'junk')");
							}catch(SQLException e){
								err("could not insert into db(MulTypeSinAns)");
							}
							break;
						}
//processing multiple choice multiple answer type questions.
						case MulTypeMulAns:{
							temp = "";
							if(Value[i-1].equals("")) t = new Integer("0");
							else t = new Integer(Value[i-1]);
							for(j=1;j<=NoOps;j++){
								if(j==t.intValue()) temp +="'Y',";
								else temp += "'N',";
							}
							try{
								stmt.executeUpdate("insert into "+AnswerTableName+" values('"+FormNo+"',"+qno+","+AnsNo+",1,"+temp+"0,'junk','"+Name+"')");
							}catch(SQLException e){
								err("could not insert into db(MulTypeMulAns)");
							}
							break;
						}
//processing constrained type of questions.
						case RanType:{
							try{
								if(Value[i-1].equals("")){
									stmt.executeUpdate("insert into "+AnswerTableName+" values('"+FormNo+"',"+qno+","+AnsNo+","+NoOps+","+AllNo+"null,'junk','"+Name+"')");
								}
								else{
									d = new Double(Value[i-1]);
									stmt.executeUpdate("insert into "+AnswerTableName+" values('"+FormNo+"',"+qno+","+AnsNo+","+NoOps+","+AllNo+toNumeric(d.doubleValue())+",'junk','"+Name+"')");
								}
							}catch(SQLException e){
								err("could not insert into db(RanType)");
							}
							break;
						}
//processing subjective type of questions.
						case SubType:{
						try{
							stmt.executeUpdate("insert into "+AnswerTableName+" values('"+FormNo+"',"+qno+","+AnsNo+","+NoOps+","+AllNo+"0,'"+Value[i-1]+"','"+Name+"')");
						}catch(SQLException e){
							err("could not insert into db(SubType)");
						}
							break;
						}
//show error if unknown type is encountered.
						default:{
							err("Unknown type encountered");
							result = 3;
						}
					}
				}
				if(result != 0) break;
//remember question number for next execution of loop.
				oldQno = qno;
			}
		}
//mark a flag in the database indicating that the user has given feedback.
		if(result == 0) CheckFlag();
		stmt.close();
		return result;
	}


//this function queries the database with a form number and a question
//number and returns its type. It returns -1 if an exception occurs.
	private int GetType(int qno)
	throws SQLException{
		int res=0;
		Statement stmt = conn.createStatement();
		try{
			ResultSet rset = stmt.executeQuery("select question_type from "+QuestionTableName+" where form_number='"+FormNo+"' and question_number="+qno);
			while(rset.next()) res=rset.getInt(1);
			stmt.close();
		}catch(SQLException e){
			res = -1;
		}
	 	return res;
	}


//this function sets the login_id to anonymous if so specified in the
//form description in the database.
	void SetAnonymity(){
		try{
			Statement stmt = conn.createStatement();
			ResultSet rset = stmt.executeQuery("select anonymous from "+FormTableName+" where form_number='"+FormNo+"'");
			boolean res = rset.next();
			if(res && rset.getString(1).equals("N")){
				Name = LoginId;
			}
			stmt.close();
		}catch(SQLException e){
			err("could not set anonymity");}
	}

//this function updates the "valid" flag in the database indicating that
//the user has given feedback for this form.
	private void CheckFlag()
	throws SQLException{
	  try{
		Statement stmt = conn.createStatement();
		String ss = "update "+StudentTableName+" set valid='N' where form_number='"+FormNo+"' and login_id='"+LoginId+"'";
		stmt.executeQuery(ss);
//		stmt.executeUpdate("update "+StudentTableName+" set valid='N' where form_number='"+FormNo+"' and login_id='"+LoginId+"'");
		stmt.close();
	  }catch(SQLException e){
	  	err("could not update flag");
	  }
	}

//this function truncates a double to have only two digits after the decimal.
	private double toNumeric(double d){
		return (double)((int)(d*100.00))/100.00;
	}
//generic print functions.
	private void print(String S){
		if(OutputDefined) out.print(S);
		else System.out.print(S);
	}
	private void println(String S){
		if(OutputDefined) out.println(S);
		else System.out.println(S);
	}
//debugging function
	private void err(String S){
		System.err.println("UpdateDb:"+S);
	}


}
